##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("tidyverse") #初めての場合のみ実行
install.packages("modelsummary") #初めての場合のみ実行
install.packages("estimatr") #初めての場合のみ実行
install.packages("lmtest") #初めての場合のみ実行(Wald検定に使用)
library("tidyverse")
library("modelsummary")
library("estimatr") #ロバスト標準誤差を用いる場合
library("lmtest")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("black_data.csv",header=T)

## 9.3節の推定結果---------------------------------------------------------------------------
Out1<-lm(call~black,data=Data1)
Out1r<-lm_robust(call~black,data=Data1)
Out2<-lm(call~black+experience,data=Data1)
Out2r<-lm_robust(call~black+experience,data=Data1)

result9.3<-list(
  "Out1"=Out1,
  "Out1r"=Out1r,
  "Out2"=Out2,
  "Out2r"=Out2r
)
msummary(result9.3 , stars = TRUE ,fmt = '%.4f') #結果の一括表示

##9.4.2節の推定結果---------------------------------------------------------------------------
Out3r<-lm_robust(call~black+experience,data=Data1)
summary(Out3r)
Data1$p <- Out3r$fitted.values
Data1$h <- sqrt((1-Data1$p)*Data1$p)
Data1$x0 <- 1/Data1$h
Data1$call_h <- Data1$call/Data1$h
Data1$black_h <- Data1$black/Data1$h
Data1$experience_h <- Data1$experience/Data1$h

Out4 <- lm(call_h~x0+black_h+experience_h-1,data=Data1)
summary(Out4)
