##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("tidyverse") #初めての場合のみ実行
install.packages("estimatr") #初めての場合のみ実行
library("tidyverse") 
library("estimatr")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("dailyint_data.csv",header=T)
Data1$time <- 1:nrow(Data1)

##変数の定義(ドル円レートは変化率に、介入額(単位億円)は介入額(単位兆円)に変換)---------------------------------------------------------------------------
Data1$ds <- 100*(log(Data1$spot)-log(lag(Data1$spot)))
Data1$intj <- Data1$intervention/10000

head(Data1)

## 7.4.2節の推定結果(supF検定と構造変化日の特定)---------------------------------------------------------------------------
Out1 <- lm(ds ~ intj , data=Data1)
summary(Out1)

fs1 <- Fstats(ds~intj, data = Data1,from = 0.15 , to = 0.85)
fs <- fs1$Fstats
Data2 <- Data1[(459:2596),]　#両端15％をカット
Data3 <- cbind(Data2,fs)
Data3[,1] <- as.Date(Data3[,1],"%m/%d/%Y")
Data3
plot(Data3$date,Data3$fs,type="l") #wald統計量の推移
max(Data3$fs) 
  ##33.899と計算されるが制約数が２であるため、２で除すと16.945となり教科書と一致
Data3[Data3$fs >= 33.8,] #構造変化点


##前半(1995/4/18まで)と後半(1995/4/19から)で分けて、別々に推定する---------------------------------------------------------------------------
Out2 <- lm(ds ~ intj , subset = (time <= 1056),data=Data1)
Out3 <- lm(ds ~ intj , subset = (time > 1056),data=Data1)

mtable(Out2,Out3)

##推定結果の頑健性を調べるため、説明変数に新たにdsの1期前の値を加える---------------------------------------------------------------------------
Out4 <- lm(ds ~ intj + lag(ds) , data=Data1)
summary(Out4)
 
fs2 <- Fstats(ds~intj+lag(ds), data = Data1,from = 0.15 , to = 0.85)
fs2_1 <- fs2$Fstats
Data4 <- Data1[(459:2597),] #両端15％をカット
Data5 <- cbind(Data4,fs2_1)
Data5[,1] <- as.Date(Data5[,1],"%m/%d/%Y")
plot(Data5$date,Data5$fs2_1,type="l")
max(Data5$fs2_1)
Data5[Data5$fs2_1 >= 39.4,] #構造変化点

##構造変化日は1072(1995/5/10)となっているので、TBは1071(1995/5/9)下では、構造変化前後で別々に推定する
Out5 <- lm(ds ~ intj + lag(ds),subset = (time <= 1071),data=Data1)
Out6 <- lm(ds ~ intj + lag(ds),subset = (time > 1071),data=Data1)

mtable(Out5,Out6)


