##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("tidyverse") #初めての場合のみ実行
install.packages("memisc") #初めての場合のみ実行
library("tidyverse")
library("memisc")


##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("demography_data.csv",header = T)
str(Data2) #データの属性を確認する

Data2 <-
  Data1 %>%
  mutate(region_code = as.numeric(factor(region))) #regionが文字列(string)なので、これを数値に変換する
table(Data2$region_code) #region_codeは1から7までの数値であることを確認する

Data2$gdp2015 <- log(Data2$rgdp2015/Data2$pop2015)  #2015年の1人当たりGDPの対数
Data2$gdp1990 <- log(Data2$rgdp1990/Data2$pop1990)  #1990年の1人当たりGDPの対数
Data2$dgdp <- Data2$gdp2015 - Data2$gdp1990  #1990年から2015年にかけてのGDP変化率
Data2$ddepend <- Data2$depend2015 - Data2$depend1990  #高齢者割合の変化*/
Data2$lpop1990 <- log(Data2$pop1990)

summary(Data2) #基本統計量を調べる

##説明変数に人口比を用いた推定---------------------------------------------------------------------------
Out1<-lm(dgdp~ddepend,data = Data2)
Out2<-lm(dgdp~ddepend+gdp1990 ,data = Data2) #コントロール変数として、1990年のGDPを追加
Out3<-lm(dgdp~ddepend+gdp1990+lpop1990+depend1990+factor(region_code) ,data = Data2) #1990年の人口、高齢者割合、地域ダミーを追加

summary(Out1)
summary(Out2)
summary(Out3) #地域別効果の係数が表示される


##練習問題、説明変数に平均年齢を用いた推定---------------------------------------------------------------------------

Data2$ddepend2=Data2$depend2015_ave - Data2$depend1990_ave

Out4<-lm(dgdp ~ddepend2,data=Data2)
Out5<-lm(dgdp ~ ddepend2 + gdp1990 + lpop1990 + depend1990_ave + factor(region_code),data=Data2)

summary(Out4)
summary(Out5)
mtable(Out4,Out5)
