##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行
install.packages("rdrobust") #初めての場合のみ実行
library("estimatr")
library("rdrobust")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("election_data.csv",header=T)
head(Data1)
##変数の定義---------------------------------------------------------------------------
Data1$W <- Data1$diff_share
Data1$X <- as.numeric(Data1$W>=0)
Data1$Y <- as.numeric(Data1$myoutcomenext)
Data2 <- na.omit(Data1)

##14.4節の推定結果---------------------------------------------------------------------------
rdplot(y = Data2$Y,x = Data2$W , x.lim = c(-0.2,0.2))

Data2$W2 <- (Data2$W)^2
Data2$W3 <- (Data2$W)^3
Data2$WX <- (Data2$W)*(Data2$X)
Data2$WX2 <- (Data2$W2)*(Data2$X)
Data2$WX3 <- (Data2$W3)*(Data2$X)

Out1 <- lm_robust(Y ~ X + W + W2 + W3 + WX + WX2 +WX3 ,
                  data = Data2 , subset = (W>=-0.2 & W<=0.2))
summary(Out1)

##練習問題---------------------------------------------------------------------------
Out2 <- lm_robust(Y ~ X + W + WX,
                  data = Data2 , subset = (W>=-0.15 & W<=0.15))
summary(Out2)

##バンド幅と乗数を最適に選択するコマンド---------------------------------------------------------------------------
rd <- rdrobust(Data2$Y , Data2$W , kernel = "tri", c = 0)
summary(rd)