##はじめに------------------------------------------------------------------------------------------------------------------------
###任意のフォルダを作業ディレクトリに指定
###Rの上部メニューの「ファイル」＞「作業ディレクトリの変更」で指定可能　
 ###※MacOSの場合は「その他」＞「作業ディレクトリの変更」
###Rstudioの場合は「Session」＞「Set Working Directory」＞「Choose Directory」で指定可能
###分析において、この作業ディレクトリ内にあるcsvファイルを読み込んだりする

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("tidyverse")
library("tidyverse")

##データの読み込み----------------------------------------------------------------------------------------------------
Data1<-read.csv("gay_data.csv",header=TRUE) #Data1にcsvファイルの内容を格納。header=TRUEで１行目をヘッダーとする


##データの確認----------------------------------------------------------------------------------------------------
str(Data1) #データの属性を確認する
summary(Data1) #基本統計量を調べる


## 2.4節の推定結果----------------------------------------------------------------------------------------------------
Out1<-lm(gay~support,data=Data1) #被説明変数をgay、説明変数をsupportとしたOLS推定
#lm(被説明変数~説明変数,data=使用データ)と入力する

summary(Out1) #上記のOLS推定の結果を表示

predict(Out1,newdata=data.frame(support=100)) #support=100としたときの予測値

## 散布図と標本相関係数----------------------------------------------------------------------------------------------------
par(family= "HiraKakuProN-W3")　#日本語表示を可能にするコマンド（2023/12/21時点での対処法）

plot(Data1$support,Data1$gay,main="散布図と回帰直線",
     xlab = "Support",ylab = "Gay", col = "red", pch = 19) #pch=19 で塗りつぶし丸印を指定

abline(Out1,col = "blue") #散布図に回帰直線を入れる

cor(Data1$support,Data1$gay) #相関係数「参照元データ$項目名」という形式