##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("tidyverse") #初めての場合のみ実行
install.packages("memisc") #初めての場合のみ実行
install.packages("estimatr") #初めての場合のみ実行
install.packages("lmtest") #初めての場合のみ実行(Wald検定に使用)
install.packages("strucchange")
library("tidyverse")
library("memisc")
library("estimatr")
library("lmtest")
library("strucchange")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("growth_data.csv",header=T)

##　変数の定義---------------------------------------------------------------------------
which(Data1 == "Mar-91") #1991年が何行目にあるか
Data1$d1991<-ifelse(1:nrow(Data1) <= 41, 0, 1)
Data1$d1991growth<-Data1$d1991*lag(Data1$growth)

##　作図---------------------------------------------------------------------------
Growth<-ts(Data1$growth,start = c(1981,1),frequency = 4)
plot(Growth,type = "l", col = "blue",xlab = "year",ylab = "growth")

## 7.4.1節の推定結果
Out1<-lm(growth~lag(growth),data=Data1)
Out2<-lm(growth~lag(growth)+d1991+d1991growth,data=Data1)

summary(Out1)
summary(Out2)
mtable(Out1,Out2)

waldtest(Out2, terms = c("d1991", "d1991growth"))　#Out2のモデル式の"d1991", "d1991growth"について同時検定

 ###構造変化日はtq(1991Q2)とした。

## 7.4.2節の推定結果
fs <- Fstats(growth~lag(growth), data = Data1,from = 0.15 , to = 0.85)
fstat <- ts(fs$Fstats,start = c(1985,1),frequency = 4)
print(fstat)
plot(fstat) #stataのsupFの値とは異なるものの、構造変化点となる時点は一致する。