##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行
install.packages("tidyverse") #初めての場合のみ実行
install.packages("sandwich") #初めての場合のみ実行
install.packages("lmtest") #初めての場合のみ実行
install.packages("margins")　#初めての場合のみ実行
library("estimatr")
library("tidyverse")
library("sandwich")
library("lmtest")
library("margins")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("mariage_data.csv",header=T)

##12.1.1節の推定結果(50歳以下の男性に限定した分析)---------------------------------------------------------------------------
Out1<-lm(partner~age,data=Data1,subset = (male == 1 & age <= 50))
summary(Out1)
predict_25 <- predict(Out1,newdata = data.frame(age=25))
predict_50 <- predict(Out1,newdata = data.frame(age=50))
print(c(predict_25,predict_50))

## 12.1.2節の推定結果(50歳以下の男性に限定した分析)---------------------------------------------------------------------------
Out2<-glm(partner~age,subset = (male == 1 & age <= 50),
          data=Data1,family = binomial(probit))
summary(Out2)
predict_25pr <- predict(Out2,newdata = data.frame(age=25),
                        type = "response")
predict_50pr <- predict(Out2,newdata = data.frame(age=50),
                        type = "response")
print(c(predict_25pr,predict_50pr))

##12.1.3節の図---------------------------------------------------------------------------
Data2 <- Data1 %>% 
  dplyr::filter(age <= 50 , male == 1)
Data2$p_partner <- pnorm(predict(Out2,type = "link"))
par(family= "HiraKakuProN-W3")
plot(Data2$age, Data2$p_partner, main = "プロビットモデルにおける限界効果",
     xlab = "年齢",ylab = "予測値", col = "blue" , pch = 18)

##12.1.3節の推定結果(50歳以下の男性に限定した分析)---------------------------------------------------------------------------
Out3<-lm_robust(partner ~ age + undergrad + grad, data = Data1,
                subset = (male == 1 & age <= 50))
summary(Out3) # Adjusted R-squaredで調整済決定係数を確認(コード省略)

Out4<-glm(partner~age + undergrad + grad,subset = (male == 1 & age <= 50),
          data=Data1,family = binomial(probit))
coeftest(Out4,vcov = vcovHC(Out4,type = "HC0")) 
Out4_margins <- margins(Out4, variables = c("age", "undergrad", "grad"))
summary(Out4_margins) #係数はアルファベット順で

##12.1.3節の推定結果(50歳以下の女性に限定した分析)---------------------------------------------------------------------------

Out5<-lm_robust(partner ~ age + undergrad + grad, data = Data1,
                subset = (male == 0 & age <= 50))
summary(Out5) # Adjusted R-squaredで調整済決定係数を確認(コード省略)

Out6<-glm(partner~age + undergrad + grad,subset = (male == 0 & age <= 50),
          data=Data1,family = binomial(probit))
coeftest(Out6,vcov = vcovHC(Out6,type = "HC0")) 
Out6_margins <- margins(Out6, variables = c("age", "undergrad", "grad"))
summary(Out6_margins) #係数はアルファベット順で       

##練習問題の推定結果(50歳以下の男性)---------------------------------------------------------------------------

Out7 <- glm(partner ~ age + undergrad + grad, subset = (male == 1 & age <= 50),
            data = Data1, family = binomial(link = "probit"))
coeftest(Out7,vcov = vcovHC(Out7,type = "HC0")) 

coefficients <- coef(Out7)

p_grad <- pnorm(coefficients['(Intercept)'] + coefficients["age"] * Data1$age + coefficients['undergrad'] * 0 + coefficients['grad'] * 1)
p_no <- pnorm(coefficients['(Intercept)'] + coefficients['age'] * Data1$age + coefficients['undergrad'] * 0 + coefficients['grad'] * 0)

plot(Data1$age, p_grad, xlab = "age", ylab = "p_grad", main = "Scatter Plot of p_grad and p_no against age", col = "blue")
points(Data1$age, p_no, col = "red")
legend("bottomright", legend = c("p_grad", "p_no"), col = c("blue", "red"), pch = 1)

