##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("tidyverse") #初めての場合のみ実行
install.packages("memisc") #初めての場合のみ実行
library("tidyverse")
library("memisc")

##データの読み込み）---------------------------------------------------------------------------
Data1<-read.csv("money_data.csv",header=T)

##変数の定義---------------------------------------------------------------------------
Data1$lnm <- log(Data1$M1 / Data1$NGDP)
Data1$lnr <- log(Data1$interest)

str(Data1) #データの属性を確認する
summary(Data1) #基本統計量を調べる

##四半期データ(1980Q1-2013Q4) ※変数の定義をしてから時系列データとして読み込みをする---------------------------------------------------------------------------
Data1<-ts(Data1,start = c(1980, 1),frequency = 4) #四半期データ

##6.3.2節の推定---------------------------------------------------------------------------
Out1<-lm(lnm ~ lnr,data = Data1) #対数対数モデル
Out2<-lm(lnm ~ interest, data = Data1) #対数線形モデル

summary(Out1)
summary(Out2)
mtable(Out1,Out2)
