##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行
library("estimatr")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("mwage_data.csv",header=T)

##変数を定義する---------------------------------------------------------------------------
Data1$timestate <- Data1$time*Data1$state
head(Data1)

##14.3.1節の推定結果---------------------------------------------------------------------------
mean(Data1$fulltime[Data1$state == 1 & Data1$time == 0],na.rm = T) #NJ州介入前
mean(Data1$fulltime[Data1$state == 1 & Data1$time == 1],na.rm = T) #NJ州介入後
mean(Data1$fulltime[Data1$state == 0 & Data1$time == 0],na.rm = T) #PA州介入前
mean(Data1$fulltime[Data1$state == 0 & Data1$time == 1],na.rm = T) #PA州介入後

Out1 <- lm_robust(fulltime ~ state + time + timestate,
                  clusters = store , se_type = "stata" , data = Data1)
summary(Out1)

Out2 <- lm_robust(fulltime ~ time + timestate + factor(store)-1,
                  clusters = store , se_type = "stata" , data = Data1)
pass2 <- summary(Out2)
result2 <- pass2$coefficients
print(result2[c(1:2),])

## 練習問題の推定結果(営業時間とレジ台数を加える)
Out3 <- lm_robust(fulltime ~ state + time + timestate + hours + register,
                  clusters = store , se_type = "stata" , data = Data1)
summary(Out3)

Out4 <- lm_robust(fulltime ~ time + timestate + hours + register + factor(store)-1,
                  clusters = store , se_type = "stata" , data = Data1)
pass4 <- summary(Out4)
result4 <- pass4$coefficients
print(result4[c(1:4),])