##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行
install.packages("sandwich")
install.packages("margins")
install.packages("lmtest")
library("estimatr")
library("sandwich")
library("margins")
library("lmtest")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("participation_data.csv",header=T)

##変数の定義---------------------------------------------------------------------------
Data1$full <- as.numeric(Data1$job == 1)
Data1$part <- as.numeric(Data1$job == 2)
Data1$work <- Data1$full + Data1$part
Data1$under6 <- as.numeric(Data1$yongest < 6)
head(Data1)

##12.6節の推定結果(50歳以下の男性に限定した分析)---------------------------------------------------------------------------
Out1 <- lm_robust(work ~ experience + undergrad + grad + partner + under6 + children ,
                  subset = (male == 1 & age <= 50),data = Data1)
summary(Out1) #Adjusted R-squared で調整済決定係数を確認（コード省略）


Out2 <- glm(work ~ experience + undergrad + grad + partner + under6 + children,
            subset = (male == 1 & age <= 50), data=Data1,family = binomial(probit))
coeftest(Out2,vcov = vcovHC(Out2,type = "HC0")) #若干数値が異なる
Out2_margins <- margins(Out2, variables = c("experience", "undergrad", "grad", "partner", "under6", "children"))
summary(Out2_margins) #係数はアルファベット順で


Out3 <- glm(work ~ experience + undergrad + grad + partner + under6 + children,
            subset = (male == 1 & age <= 50), data=Data1,family = binomial(logit))
coeftest(Out3,vcov = vcovHC(Out3,type = "HC0")) 
Out3_margins <- margins(Out3, variables = c("experience", "undergrad", "grad", "partner", "under6", "children"))
summary(Out3_margins) #係数はアルファベット順で

##12.6節の推定結果(50歳以下の女性に限定した分析)---------------------------------------------------------------------------
Out1w <- lm_robust(work ~ experience + undergrad + grad + partner + under6 + children ,
                  subset = (male == 0 & age <= 50),data = Data1)
summary(Out1w) #Adjusted R-squared で調整済決定係数を確認（コード省略）


Out2w <- glm(work ~ experience + undergrad + grad + partner + under6 + children,
            subset = (male == 0 & age <= 50), data=Data1,family = binomial(probit))
coeftest(Out2w,vcov = vcovHC(Out2w,type = "HC0")) #若干数値が異なる
Out2w_margins <- margins(Out2w, variables = c("experience", "undergrad", "grad", "partner", "under6", "children"))
summary(Out2w_margins) #係数はアルファベット順で


Out3w <- glm(work ~ experience + undergrad + grad + partner + under6 + children,
            subset = (male == 0 & age <= 50), data=Data1,family = binomial(logit))
coeftest(Out3w,vcov = vcovHC(Out3w,type = "HC0")) 
Out3w_margins <- margins(Out3w, variables = c("experience", "undergrad", "grad", "partner", "under6", "children"))
summary(Out3w_margins) #係数はアルファベット順で

