##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行
install.packages("AER") #初めての場合のみ実行
library("estimatr")
library("AER")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("protection_data.csv",header=T)
head(Data1)

##13.6節の推定結果---------------------------------------------------------------------------
Out1 <- lm_robust(gdp1995 ~ protection , data = Data1)
summary(Out1)
Out2 <- iv_robust(gdp1995 ~ protection | mortality,
                  se_type = "stata" , data=Data1)
summary(Out2)

##13.7節の推定結果---------------------------------------------------------------------------
Out3 <- iv_robust(gdp1995 ~ protection + latitude | mortality + europop + latitude,
                  se_type = "stata", data = Data1)
summary(Out3)
Out4 <- lm(protection ~ mortality + europop + latitude , data=Data1)
summary(Out4)
waldtest(Out4, terms = c("mortality", "europop"))

## 過剰識別検定---------------------------------------------------------------------------
Out5 <- ivreg(gdp1995 ~ protection + latitude | mortality + europop + latitude, data = Data1)
summary(Out5, diagnostics = TRUE)
 #Weak-instruments 弱相関検定
 #Wu-Hausman ハウスマン検定
 #Sargan 過剰識別検定

  ###13.7.3節の過剰識別性検定を行う。p値が10%を上回れば、帰無仮説が採択され(操作変数の外生性が満たされる)、
  ###p値が10%を下回れば、帰無仮説が棄却される(操作変数の外生性が満たされない)
