##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("tidyverse")
install.packages("memisc")
library("tidyverse")
library("memisc")

##データの読み込み----------------------------------------------------------------------------------------------------
Data1<-read.csv("spurious_data.csv",header=TRUE) 

##変数の定義----------------------------------------------------------------------------------------------------
Data1$dy <- Data1$Y - lag(Data1$Y)
Data1$dx <- Data1$X - lag(Data1$X)

##16.1節の分析----------------------------------------------------------------------------------------------------
###図16.1
par(family= "HiraKakuProN-W3")
plot(Data1$time,Data1$X,xlab = "年" , ylab = "水準" ,
     type = "l" , col="red" , ylim = c(-10,20) , 
     main = "変数XとYの推移")
par(new=T)
plot(Data1$time,Data1$Y,xlab = "年" , ylab = "水準" ,
     type = "l" , col="blue" ,  ylim = c(-10,20))


##見せかけの回帰----------------------------------------------------------------------------------------------------
Out1 <- lm(Y~X,data=Data1)
summary(Out1)

##トレンド変数を追加する----------------------------------------------------------------------------------------------------
Out2 <- lm(Y~X+time,data=Data1)
summary(Out2)

##階差の分析----------------------------------------------------------------------------------------------------
par(family= "HiraKakuProN-W3")
plot(Data1$time,Data1$dx,xlab = "年" , ylab = "水準" ,
     type = "l" , col="red" ,ylim = c(-4,4) , 
     main = "変数XとYの各階差の推移")
par(new=T)
plot(Data1$time,Data1$dy,xlab = "年" , ylab = "水準" ,
     type = "l" , col="blue" ,  ylim = c(-4,4))

Out3 <- lm(dy~dx , data=Data1)
summary(Out3)