##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行
library("estimatr")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("star_data.csv",header=T)

##14.2.1節の推定結果---------------------------------------------------------------------------
Out1 <- lm_robust(total_score ~ small + regular_aid + factor(school) , data=Data1)
pass1 <- summary(Out1)
result1 <-pass1$coefficients
print(result1[c(1:3),]) #学校効果を非表示
Out1$adj.r.squared #調整済決定係数

Out2 <- lm_robust(total_score ~ small + regular_aid + total_experience + factor(school) , data=Data1)
pass2 <- summary(Out2)
result2 <- pass2$coefficients
print(result2[c(1:4),]) ##学校効果を非表示
Out2$adj.r.squared #調整済決定係数


##追加推定：学校が同じ生徒であれば、誤差項が相互に相関している可能性がある。学校をクラスターと考えて、
###クラスターロバスト標準誤差を用いる
Out3 <- lm_robust(total_score~small + regular_aid + total_experience + factor(school),
                  clusters = school ,se_type = "stata", data=Data1)
pass3 <- summary(Out3)
result3 <- pass3$coefficients
print(result3[c(1:4),])
Out3$adj.r.squared #調整済決定係数


##練習問題
Out4 <- lm_robust(
  total_score~small + regular_aid + total_experience + black + boy + freelunch + factor(school), 
                  data = Data1
  ) #ロバスト標準誤差
pass4 <- summary(Out4)
result4 <- pass4$coefficients
print(result4[c(1:7),])

Out5 <- lm_robust(
  total_score~small + regular_aid + total_experience + black + boy + freelunch + factor(school), 
                  clusters = school , se_type = "stata" , data = Data1
  )#クラスターロバスト標準誤差
pass5 <- summary(Out5)
result5 <- pass5$coefficients
print(result5[c(1:7),])



