##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行

library("estimatr")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("stayhome_data.csv",header=T)
str(Data1)
summary(Data1)

##変数の定義---------------------------------------------------------------------------
Data1$drain<-as.numeric(Data1$rain > 0)
Data1$linf<-log(Data1$infection+sqrt((Data1$infection)^2+1))
Data1$emerg <-Data1$emerg_start - Data1$emerg_end
Data1$close <- Data1$close_start - Data1$close_end
Data1

##11.4.2節の推定結果---------------------------------------------------------------------------
Out1<-lm_robust(stay~close+emerg+linf+drain+factor(prefecture)+factor(date),
                clusters = prefecture ,se_type = "stata",
                weights = mobilephones ,data=Data1)
pass1<-summary(Out1)
result1<-pass1$coefficients[
  !grepl("factor\\(prefecture\\)",
         rownames(pass1$coefficients)), ,drop = FALSE
]  
print(result1[2:5,]) #推定結果

