##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行

library("estimatr")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("suicide_data.csv",header=T)

##11.3.1節の推定---------------------------------------------------------------------------
Out1<-lm_robust(suicide~unemployment,
                
                ) #プールド回帰
result1<-summary(Out1)
print(result1) #結果の表示
result1$adj.r.squared #調整済決定係数

Out2<-lm_robust(suicide~unemployment+factor(country_name),
                clusters = country_name,se_type = "stata",data=Data1)
pass2<-summary(Out2)
result2 <-pass2$coefficients[!grepl("factor\\(country_name\\)",rownames(pass2$coefficients)), ,drop = FALSE] 
### 上のコマンドは地域ダミーの推定結果を出力しない
###  \\　の記号は、() をRで文字列として読ませるための記号
print(result2)
pass2$adj.r.squared


## 11.4.2節の推定---------------------------------------------------------------------------
Out3<-lm_robust(suicide~unemployment+factor(country_name),
                clusters = country_name,se_type = "stata",data=Data1)
pass3<-summary(Out3)
result3 <-pass3$coefficients[!grepl("factor\\(country_name\\)",rownames(pass3$coefficients)), ,drop = FALSE] 
print(result3)
pass3$adj.r.squared

 ## 個別効果と時間効果を考慮した固定効果モデル
Out4<-lm_robust(suicide~unemployment+factor(country_name)+factor(year),
                clusters = country_name,se_type = "stata",data=Data1)
result4<-summary(Out4)
pass4<-summary(Out4)
result4 <-pass4$coefficients[
  !grepl("factor\\(country_name\\)",
         rownames(pass4$coefficients)), ,drop = FALSE
  ]  #国効果を非表示
print(result4[c(1,2),])　#変数の推定結果のみ表示
pass4$adj.r.squared

