##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("estimatr") #初めての場合のみ実行

library("estimatr")

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("suicidej_data.csv",header=T)
head(Data1)

##　11.4.2節 例11-3の推定結果---------------------------------------------------------------------------
Out1<-lm_robust(suicide~unemployment+factor(prefecture),
                clusters = prefecture,se_type = "stata",data=Data1) #県効果のみ
pass1<-summary(Out1) 
result1 <-pass1$coefficients[
  !grepl("factor\\(prefecture\\)",
         rownames(pass1$coefficients)),,drop = FALSE
  ] 
print(result1)
pass1$adj.r.squared

Out2<-lm_robust(suicide~unemployment+factor(prefecture)+factor(year),
                clusters = prefecture,se_type = "stata",data=Data1) #県効果の時間効果
pass2<-summary(Out2) 
result2 <-pass2$coefficients[
  !grepl("factor\\(prefecture\\)",
         rownames(pass2$coefficients)),,drop = FALSE
] 
print(result2[c(1,2),])
pass2$adj.r.squared

