##はじめに------------------------------------------------------------------------------------------------------------------------
###作業ディレクトリ等については、サポートウェブサイトからダウンロードできる「同性愛者の割合」のRスクリプトを参照

##事前準備（使用するパッケージの呼び出し）---------------------------------------------------------------------------
install.packages("tidyverse") #初めての場合のみ実行
install.packages("memisc") #初めての場合のみ実行
library("tidyverse")
library("memisc") #参考で使用

##データの読み込み---------------------------------------------------------------------------
Data1<-read.csv("timss_data.csv",header=T)

##データの生成---------------------------------------------------------------------------
Data1$male = 1-Data1$female #男性ダミーの生成

 ###数学の点数を偏差値に換算する
mean_math <- mean(Data1$math) #平均値
sd_math <- sd(Data1$math) #標本標準偏差
Data1$score_math = 50+10*(Data1$math-mean_math)/sd_math #偏差値

 ###理科の点数を偏差値に換算する
mean_science <- mean(Data1$science) #平均値
sd_science = sd(Data1$science) #標本標準偏差
Data1$score_science = 50+10*(Data1$science-mean_science)/sd_science #偏差値

##データの属性と基本統計量の確認---------------------------------------------------------------------------

str(Data1) #データの属性を確認する
summary(Data1) #基本統計量を調べる

##4.5節の推定結果---------------------------------------------------------------------------
Out1<-lm(score_math~female,data=Data1) #被説明変数をscore_math、説明変数をfemaleとしたOLS推定
Out2<-lm(score_science~female,data=Data1) #被説明変数をscore_science、説明変数をfemaleとしたOLS推定

summary(Out1)
summary(Out2)

 ###参考　結果を並べて表示
mtable(Out1,Out2) #Out2とOut3の結果を並べて表示

##4章の練習問題---------------------------------------------------------------------------
Out3<-lm(score_math~male,data=Data1)
Out4<-lm(score_science~male,data=Data1)

summary(Out3)
summary(Out4)
###参考　結果を並べて表示
mtable(Out3,Out4)
mtable(Out1,Out2,Out3,Out4)


##5.9節の推定結果(2番目の推定では教育水準が不明のデータを除いた)---------------------------------------------------------------------------
Out5<-lm(score_math~birth_q2+birth_q3+birth_q4,data=Data1)
Data2<-subset(Data1, mother > 0 & father > 0) # mother = 0 かつ father = 0 のデータを取り除く処理
Out6<-lm(score_math~birth_q2+birth_q3+birth_q4,data=Data2) #取り除いたデータセットで分析

summary(Out5)
summary(Out6)
mtable(Out5,Out6)

##5章の練習問題：生まれ月を用いる、ただし、4月生まれダミーは除いた---------------------------------------------------------------------------

Out7<-lm(score_math~birth_m5+birth_m6+birth_m7+birth_m8+birth_m9+birth_m10+birth_m11+birth_m12+birth_m1+birth_m2+birth_m3,data=Data1)
Out8<-lm(score_math~birth_m5+birth_m6+birth_m7+birth_m8+birth_m9+birth_m10+birth_m11+birth_m12+birth_m1+birth_m2+birth_m3,data=Data2)

summary(Out7)
summary(Out8)
mtable(Out7,Out8)

##追加推定1：学校ごとの違いを考慮するために、学校ダミーをいれた推定---------------------------------------------------------------------------

Out9<-lm(score_math~birth_q2+birth_q3+birth_q4+factor(school),data = Data1)

Data3<-summary(Out9) # Data3 に推定結果を格納
Result <-Data3$coef[!grepl("factor\\(school\\)", rownames(Data3$coef)), , drop = FALSE] 
 ### 上のコマンドは学校ダミーの推定結果を出力しない
 ###  \\　の記号は、() をRで文字列として読ませるための記号

Result #学校ダミーの推定結果以外の推定結果を表示



